<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/31/2003 *
 * ===============                              Last change: 07/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : admin.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Administration module                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Administrationsmodul                             *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Login is default
if ((empty($GLOBALS['action'])) && ($check == "admin_only"))
{
	// Redirect to right URL
	LOAD_URL(URL."/modules.php?module=admin&amp;action=login");
}

// Load include file
require_once(PATH."inc/modules/admin/admin-inc.php");

// Fix "deleted" cookies in PHP4 (PHP5 does remove them, PHP4 sets them to deleted!)
FIX_DELETED_COOKIES(array('admin_login', 'admin_md5', 'admin_last', 'admin_to'));

// Is the logout empty?
if (empty($_GET['logout'])) $_GET['logout'] = "";

if (!admin_registered)
{
	// Admin is not registered so we have to inform the user
	if ((isset($_POST['ok'])) && ((empty($_POST['login'])) || (empty($_POST['pass'])) || (strlen($_POST['pass']) < 4))) $_POST['ok'] = "***";
	if ((isset($_POST['ok'])) && ($_POST['ok'] != "***"))
	{
		// Hash the password with our new generateHash() function
		$hashedPass = generateHash($_POST['pass']);

		// If the password has not been hashed we have to fall-back to md5()
		if ($hashedPass == $_POST['pass']) $hashedPass = md5($hashedPass);

		// Do registration
		$ret = REGISTER_ADMIN($_POST['login'], $hashedPass);
		switch ($ret)
		{
		case "done":
			admin_WriteData(PATH."inc/config.php", "ADMIN-SETUP", "define ('admin_registered', ", ");", "true", 0);
			if (!_FATAL)
			{
				$URL = URL."/modules.php?module=admin&amp;action=login&register=done";
				LOAD_URL($URL);
				die($URL);
			}
			 else
			{
				$ret = ADMIN_CANNOT_COMPLETE;
			}
			break;

		case "failed":
			$ret = ADMIN_REGISTER_FAILED;
			break;

		case "already":
		default:
			if ($ret == "already")
			{
				// Admin does already exists!
				$ret = ADMIN_LOGIN_ALREADY_REG;
			}
			 else
			{
				// Any other kind
				$ret = "done";
			}
			if (!admin_registered)
			{
				// Write to config that registration is done
				admin_WriteData(PATH."inc/config.php", "ADMIN-SETUP", "define ('admin_registered', ", ");", "true", 0);

				// Load URL for login
				$URL = URL."/modules.php?module=admin&amp;action=login";
				LOAD_URL($URL);
			}
			break;
		}
	}
	if ($ret != "done")
	{
		// Fixes another "Notice"
		if (!empty($_POST['login'])) {
			define('__LOGIN_VALUE', $_POST['login']);
		} else {
			define('__LOGIN_VALUE', "");
		}

		// Yet-another "Notice" fix
		if ((!empty($_POST['ok'])) && ($_POST['ok'] == "***"))
		{
			// No login entered?
			if (empty($_POST['login'])) $MSG1 = ADMIN_NO_LOGIN;

			// An error comes back from registration?
			if (!empty($ret)) $MSG1 = $ret;

			// No password entered?
			if (empty($_POST['pass'])) $MSG2 = ADMIN_NO_PASS;

			// Or password too short?
			if (strlen($_POST['pass']) < 4) $MSG2 = ADMIN_SHORT_PASS;

			// Output error messages
			define('__MSG_LOGIN', LOAD_TEMPLATE("admin_login_msg", true, $MSG1));
			define('__MSG_PASS',  LOAD_TEMPLATE("admin_login_msg", true, $MSG2));

			// Reset variables
  			$MSG1 = ""; $MSG2 = "";
  		}
		 else
		{
			// Reset values to nothing
			define('__MSG_LOGIN', "");
			define('__MSG_PASS' , "");
		}

		// Load register template
		LOAD_TEMPLATE("admin_reg_form");
	}
}
 elseif ((empty($_COOKIE['admin_login'])) || (empty($_COOKIE['admin_md5'])) || (empty($_COOKIE['admin_last'])) || (empty($_COOKIE['admin_to'])) || (($_COOKIE['admin_last'] + bigintval($_COOKIE['admin_to']) * 3600 * 24) < time()))
{
	// At leat one administrator account was created
	if ((!empty($_COOKIE['admin_login'])) && (!empty($_COOKIE['admin_md5'])) && (!empty($_COOKIE['admin_last'])) && (!empty($_COOKIE['admin_to'])))
	{
		// Timeout for last login, we have to logout first!
		$URL = URL."/modules.php?module=admin&amp;action=login&amp;logout=1";
		LOAD_URL($URL);
	}
	if (!empty($_GET['register']))
	{
		// Registration of first admin is done
		if ($_GET['register'] == "done") OUTPUT_HTML ("<STRONG class=\"admin\">".ADMIN_REGISTER_DONE."</STRONG>");
	}

	// Check if the admin has submitted data or not
	$ret = "";
	if ((isset($_POST['ok'])) && ((empty($_POST['login'])) || (empty($_POST['pass'])) || (strlen($_POST['pass']) < 4))) $_POST['ok'] = "***";
	if ((isset($_POST['ok'])) && ($_POST['ok'] != "***"))
	{
		// All required data was entered so we check his account
		$ret = CHECK_ADMIN_LOGIN($_POST['login'], $_POST['pass']);
		switch ($ret)
		{
		case "done": // Admin and password are okay, so we log in now
			$TIMEOUT = time() + (3600 * 24 * $_POST['timeout']);
			if ((@setcookie("admin_md5", generatePassString(generateHash($_POST['pass'], __SALT)), $TIMEOUT, COOKIE_PATH)) && (@setcookie("admin_login", $_POST['login'], $TIMEOUT, COOKIE_PATH)) && (@setcookie("admin_last", time(), $TIMEOUT, COOKIE_PATH)) && (@setcookie("admin_to", $_POST['timeout'], $TIMEOUT, COOKIE_PATH)))
			{
				// Construct URL and redirect
				$URL = URL."/modules.php?module=admin&amp;";

				// Rewrite overview module
				if ($GLOBALS['what'] == "overview") {
					$GLOBALS['action'] = GET_ACTION($GLOBALS['module'], $GLOBALS['what']);
				}

				// Add data to URL
				if (!empty($GLOBALS['what'])) $URL .= "what=".$GLOBALS['what'];
				 elseif (!empty($GLOBALS['action'])) $URL .= "action=".$GLOBALS['action'];
				 elseif (!empty($_GET['area'])) $URL .= "area=".$_GET['area'];

				// Load URL
				LOAD_URL($URL);
			}
			 else
			{
				OUTPUT_HTML ("<STRONG class=\"admin_fatal\">".ADMIN_LOGIN_FAILED."</STRONG>");
				ADD_FATAL(CANNOT_REGISTER_SESS);
			}
			break;

		case "404": // Administrator login not found
			$_POST['ok'] = $ret;
			$ret = ADMIN_NOT_FOUND;
			break;

		case "pass": // Wrong password
			$_POST['ok'] = $ret;
			$ret = WRONG_PASS;
			break;
		}
	}
	if ($ret != "done")
	{
		if (!empty($_POST['login']))
		{
			define('__LOGIN_VALUE', $_POST['login']);
		}
		 else
		{
			define('__LOGIN_VALUE', "");
		}

		if (isset($_POST['ok']))
		{
			// Set messages to zero

			$MSG1 = ""; $MSG2 = "";
			// No login entered?
			if (empty($_POST['login'])) $MSG1 = ADMIN_NO_LOGIN;

			// An error comes back from login?
			if ((!empty($ret)) && ($_POST['ok'] == "404")) $MSG1 = $ret;

			// No password entered?
			if (empty($_POST['pass'])) $MSG2 = ADMIN_NO_PASS;

			// Or password too short?
			if (strlen($_POST['pass']) < 4) $MSG2 = ADMIN_SHORT_PASS;

			// An error comes back from login?
			if ((!empty($ret)) && ($_POST['ok'] == "pass")) $MSG2 = $ret;

			// Load message template
			define('__MSG_LOGIN', LOAD_TEMPLATE("admin_login_msg", true, $MSG1));
			define('__MSG_PASS' , LOAD_TEMPLATE("admin_login_msg", true, $MSG2));

			// Reset variables
  			$MSG1 = ""; $MSG2 = "";
  		}
		 else
		{
			// Set constants to empty for hiding them
			define('__MSG_LOGIN', "");
			define('__MSG_PASS' , "");
		}

		// Load login form
		if (!empty($GLOBALS['what']))
		{
			// Restore old what value
			$content = array('target' => "what", 'value' => $GLOBALS['what']);
		}
		 elseif (!empty($GLOBALS['action']))
		{
			if ($GLOBALS['action'] != "logout")
			{
				// Restore old action value
				$content = array('target' => "action", 'value' => $GLOBALS['action']);
			}
			 else
			{
				// Set default values
				$content = array('target' => "action", 'value' => "login");
			}
		}
		 elseif (!empty($_GET['area']))
		{
			// Restore old area value
			$content = array('target' => "area", 'value' => $_GET['area']);
		}
		 else
		{
			// Set default values
			$content = array('target' => "action", 'value' => "login");
		}

		// Load login form template
		LOAD_TEMPLATE("admin_login_form", false, $content);
	}
}
 elseif ($_GET['logout'] == "1")
{
	// Only try to remove cookies
	if (@setcookie("admin_login", "", (time() - 3600), COOKIE_PATH) && @setcookie("admin_md5", "", (time() - 3600), COOKIE_PATH) && @setcookie("admin_last", "", (time() - 3600), COOKIE_PATH) && @setcookie("admin_to", "", (time() - 3600), COOKIE_PATH))
	{
		// Also remove array elements
		unset($_COOKIE['admin_login']);
		unset($_COOKIE['admin_md5']);
		unset($_COOKIE['admin_last']);
		unset($_COOKIE['admin_to']);

		// Destroy session
		@session_destroy();

		// Load logout template
		LOAD_TEMPLATE("admin_logout");
	}
	 else
	{
		// Something went wrong here...
		OUTPUT_HTML ("<STRONG class=\"admin_fatal\">".ADMIN_LOGOUT_FAILED."</STRONG>");

		// Add fatal message
		ADD_FATAL(CANNOT_UNREG_SESS);
	}
}
 else
{
	// Maybe an Admin want's to login?
	$ret = CHECK_ADMIN_COOKIES(SQL_ESCAPE($_COOKIE['admin_login']), SQL_ESCAPE($_COOKIE['admin_md5']));
	switch ($ret)
	{
	case "done":
		// Cookie-Data accepted
		$TIMEOUT = time() + bigintval($_COOKIE['admin_to']);
		if ((@setcookie("admin_md5", SQL_ESCAPE($_COOKIE['admin_md5']), $TIMEOUT, COOKIE_PATH)) && (@setcookie("admin_login", SQL_ESCAPE($_COOKIE['admin_login']), $TIMEOUT, COOKIE_PATH)) && (@setcookie("admin_last", time(), $TIMEOUT, COOKIE_PATH)) && (@setcookie("admin_to", bigintval($_COOKIE['admin_to']), $TIMEOUT, COOKIE_PATH)))
		{
			// Ok, Cookie-Update done
			if ((EXT_IS_ACTIVE("admins")) && (GET_EXT_VERSION("admins") > "0.2"))
			{
				// Check if action GET variable was set
				$act = SQL_ESCAPE($GLOBALS['action']);
				if (!empty($GLOBALS['what'])) {
					// Get action value by what-value
					$act = GET_ACTION("admin", $GLOBALS['what']);
				}

				// Check for access control line of current menu entry
				define('__ACL_ALLOW', ADMINS_CHECK_ACL($act, $GLOBALS['what']));
			}
			 else
			{
				// Extension not installed so it's always allowed to access everywhere!
				define('__ACL_ALLOW', true);
			}

			// When type of admin menu is not set fallback to old menu system
			if (empty($CONFIG['admin_menu'])) $CONFIG['admin_menu'] = "OLD";

			// Check for version and switch between old menu system and new "intelligent menu system"
			if ((ADMIN_CHECK_MENU_MODE() == "NEW") && (file_exists(PATH."inc/modules/admin/la_sys-inc.php")))
			{
				// Default area is the entrance, of course
				$area = "entrance";

				// Check for similar URL variable
				if (!empty($_GET['area'])) $area = $_GET['area'];

				// Load "logical-area menu-system" file
				require_once(PATH."inc/modules/admin/la_sys-inc.php");

				// Create new-style menu system will "logical areas"
				ADMIN_LOGICAL_AREA_SYSTEM($area, $act, $GLOBALS['what']);
			}
			 else
			{
				// This little call constructs the whole default old and lacky menu system
				// on left side
				ADMIN_DO_ACTION($GLOBALS['what']);
			}
		}
		 else
		{
			// Login failed (cookies enabled?)
			OUTPUT_HTML ("<STRONG class=\"admin_fatal\">".ADMIN_LOGIN_FAILED."</STRONG>");
			ADD_FATAL(CANNOT_RE_REGISTER_SESS);
		}
		break;

	case "404": // Administrator login not found
		$_POST['ok'] = $ret;
		ADD_FATAL(ADMIN_NOT_FOUND);
		break;

	case "pass": // Wrong password
		$_POST['ok'] = $ret;
		ADD_FATAL(WRONG_PASS);
		break;
	}
}

if (admin_registered)
{
	// Check config.php and inc directory for right access rights
	if (is_INCWritable("config"))     ADD_FATAL(FATAL_CONFIG_WRITABLE);
	if (is_INCWritable("dummy"))      ADD_FATAL(FATAL_INC_WRITABLE);
}
//
?>
